Find out which users are hogging the most disk space on our data serverquotas not linked to users but to directoriesWhich installed software packages use the most disk space on Debian?How to find free disk space and analyze disk usage?How to find out what is wasting space on “/”?Which directory is taking up the most spacedu space more than the disk sizeFind out most frequent strings in section of fileFigure out the total disk space utilization per processFind out which process has data open on the hard drive that is no longer visible in the directory treeHow do I find what's hogging my storage space?Unable to find disk space usage

Short story about space worker geeks who zone out by 'listening' to radiation from stars

What is paid subscription needed for in Mortal Kombat 11?

System.debug(JSON.Serialize(o)) Not longer shows full string

How to run a prison with the smallest amount of guards?

Applicability of Single Responsibility Principle

How to draw lines on a tikz-cd diagram

Why are there no referendums in the US?

What is the intuitive meaning of having a linear relationship between the logs of two variables?

How to safely derail a train during transit?

How can a function with a hole (removable discontinuity) equal a function with no hole?

Fastening aluminum fascia to wooden subfascia

How can I kill an app using Terminal?

Did Dumbledore lie to Harry about how long he had James Potter's invisibility cloak when he was examining it? If so, why?

How to be diplomatic in refusing to write code that breaches the privacy of our users

How to Reset Passwords on Multiple Websites Easily?

Customer Requests (Sometimes) Drive Me Bonkers!

Why not increase contact surface when reentering the atmosphere?

Was Spock the First Vulcan in Starfleet?

A particular customize with green line and letters for subfloat

What is the best translation for "slot" in the context of multiplayer video games?

How to write papers efficiently when English isn't my first language?

Term for the "extreme-extension" version of a straw man fallacy?

Class Action - which options I have?

Avoiding estate tax by giving multiple gifts



Find out which users are hogging the most disk space on our data server


quotas not linked to users but to directoriesWhich installed software packages use the most disk space on Debian?How to find free disk space and analyze disk usage?How to find out what is wasting space on “/”?Which directory is taking up the most spacedu space more than the disk sizeFind out most frequent strings in section of fileFigure out the total disk space utilization per processFind out which process has data open on the hard drive that is no longer visible in the directory treeHow do I find what's hogging my storage space?Unable to find disk space usage













0















We are supposed to store our ongoing projects on a rather small (~4TB) data server. Not surprisingly, it is constantly overflowing and people need to move off less recent files manually.

Is there an easy (aka standard command-line) way to find out which users take up the most space in a directory? i.e. summing up the size of all files in a directory and all sub-directories belonging to each user?



Edit: ideally not following symlinks










share|improve this question









New contributor




MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.















  • 1





    Have you considered enabling disk quotas?

    – Kusalananda
    yesterday
















0















We are supposed to store our ongoing projects on a rather small (~4TB) data server. Not surprisingly, it is constantly overflowing and people need to move off less recent files manually.

Is there an easy (aka standard command-line) way to find out which users take up the most space in a directory? i.e. summing up the size of all files in a directory and all sub-directories belonging to each user?



Edit: ideally not following symlinks










share|improve this question









New contributor




MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.















  • 1





    Have you considered enabling disk quotas?

    – Kusalananda
    yesterday














0












0








0








We are supposed to store our ongoing projects on a rather small (~4TB) data server. Not surprisingly, it is constantly overflowing and people need to move off less recent files manually.

Is there an easy (aka standard command-line) way to find out which users take up the most space in a directory? i.e. summing up the size of all files in a directory and all sub-directories belonging to each user?



Edit: ideally not following symlinks










share|improve this question









New contributor




MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.












We are supposed to store our ongoing projects on a rather small (~4TB) data server. Not surprisingly, it is constantly overflowing and people need to move off less recent files manually.

Is there an easy (aka standard command-line) way to find out which users take up the most space in a directory? i.e. summing up the size of all files in a directory and all sub-directories belonging to each user?



Edit: ideally not following symlinks







disk-usage sort storage






share|improve this question









New contributor




MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.











share|improve this question









New contributor




MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









share|improve this question




share|improve this question








edited yesterday







MechEng













New contributor




MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









asked yesterday









MechEngMechEng

11




11




New contributor




MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.





New contributor





MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.






MechEng is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.







  • 1





    Have you considered enabling disk quotas?

    – Kusalananda
    yesterday













  • 1





    Have you considered enabling disk quotas?

    – Kusalananda
    yesterday








1




1





Have you considered enabling disk quotas?

– Kusalananda
yesterday






Have you considered enabling disk quotas?

– Kusalananda
yesterday











2 Answers
2






active

oldest

votes


















0














To find the disk usage by all users on the disk, you can use the following script:



#! /bin/bash

DIRECTORY_TO_SCAN=/home

readarray -t user_list<<<"$(cat /etc/passwd | cut -d ':' -f 1)"

for u in "$user_list[@]" ; do
printf "Scanning for user: %30s" "$u"
du -ch $(find "$DIRECTORY_TO_SCAN" -user "$u" 2>/dev/null) 2>/dev/null | sed -e '/total/!d;s/^/ /'
done


This script will scan the list of all users, find the files you can read and they own and compute the total space those files use.




(The part below is kept for the sake of completeness)



If you want to know the full size of a directory, you can use the du command:



du -sh directory1 directory2


will print the size of the directory and all its contents.



To actually solve your problem, you could use user (or group) quotas. This would allow you to get a detailled report of how much space each user/group is taking and set hard limits about how much space they may use.






share|improve this answer










New contributor




Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.




















  • I can't actually solve the problem since I am not the admin. What usually happens is: I realise that the storage is full again and have to ask around who could free up some space. The response I usually get is: "I barely use any space on the server, so I can't". The directory tree is not branched by users, but by projects since more than one person is working on the same project.

    – MechEng
    yesterday












  • The problem with the non-admin approach is that if the permissions on a directory are set that you cannot read it/list its contents, you cannot know what is in there and cannot find the space it uses. If it is such a problem, I think the server admin should do something (like group quotas and set one group per project or set up directory quotas).

    – Simon Doppler
    yesterday











  • The solution only working for dirs that I have permission to read would be fine. I agree that it should be the responsibility of the admin... but can we for now just pretend that this is not an option and I would like an answer to the initial question.

    – MechEng
    yesterday











  • @MechEng I updated my answer with a script that does what you want

    – Simon Doppler
    yesterday


















0














In situations like this, I usually first use du -kx | sort -rn | less to list the directories in a largest-first order. That tells me where the biggest individual disk hogs are, so I'll know where to look. But as @SimonDoppler said, if you don't have at least r-x access to all the sub-directories, your listing will be incomplete: you'll only be able to get the sizes of directories you'll be able to access.



Remember: normally you only need to have write access to a directory to delete any files in it. Only if the directory has the sticky bit set (i.e. the last letter in the permission letter string is a t instead of x), you need be the owner of the file in order to delete it.



If there is no quota available, you may need to do something like this:



#!/bin/sh
if [ "$1" = "" ] || [ "$1" = "-h" ]
then
echo "Usage: $0##*/ <directory> <username(s)...>" >&2
exit 64 # EX_USAGE
fi
if ! [ -d "$1" ]
then
echo "ERROR: directory $1 does not exist" >&2
exit 66 # EX_NOINPUT
fi

REPORTROOT="$1"
shift
for U in "$@"
do
# Find all files under $REPORTROOT owned by a particular user,
# get their sizes and sum them together.
DISKUSE=$(find "$REPORTROOT" -type f -user "$U"
-exec stat -c %s + 2>/dev/null
| awk 's+=$1 END printf("%ldn", s)')
# Display the result for this user.
printf "%16s: %dn" "$U" "$DISKUSE"
done


Note that running this may take a while.



The "calculate a sum of a list of numbers" awk one-liner is from this Stack Overflow post. Note the comments of the answer.






share|improve this answer






















    Your Answer








    StackExchange.ready(function()
    var channelOptions =
    tags: "".split(" "),
    id: "106"
    ;
    initTagRenderer("".split(" "), "".split(" "), channelOptions);

    StackExchange.using("externalEditor", function()
    // Have to fire editor after snippets, if snippets enabled
    if (StackExchange.settings.snippets.snippetsEnabled)
    StackExchange.using("snippets", function()
    createEditor();
    );

    else
    createEditor();

    );

    function createEditor()
    StackExchange.prepareEditor(
    heartbeatType: 'answer',
    autoActivateHeartbeat: false,
    convertImagesToLinks: false,
    noModals: true,
    showLowRepImageUploadWarning: true,
    reputationToPostImages: null,
    bindNavPrevention: true,
    postfix: "",
    imageUploader:
    brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
    contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
    allowUrls: true
    ,
    onDemand: true,
    discardSelector: ".discard-answer"
    ,immediatelyShowMarkdownHelp:true
    );



    );






    MechEng is a new contributor. Be nice, and check out our Code of Conduct.









    draft saved

    draft discarded


















    StackExchange.ready(
    function ()
    StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508673%2ffind-out-which-users-are-hogging-the-most-disk-space-on-our-data-server%23new-answer', 'question_page');

    );

    Post as a guest















    Required, but never shown

























    2 Answers
    2






    active

    oldest

    votes








    2 Answers
    2






    active

    oldest

    votes









    active

    oldest

    votes






    active

    oldest

    votes









    0














    To find the disk usage by all users on the disk, you can use the following script:



    #! /bin/bash

    DIRECTORY_TO_SCAN=/home

    readarray -t user_list<<<"$(cat /etc/passwd | cut -d ':' -f 1)"

    for u in "$user_list[@]" ; do
    printf "Scanning for user: %30s" "$u"
    du -ch $(find "$DIRECTORY_TO_SCAN" -user "$u" 2>/dev/null) 2>/dev/null | sed -e '/total/!d;s/^/ /'
    done


    This script will scan the list of all users, find the files you can read and they own and compute the total space those files use.




    (The part below is kept for the sake of completeness)



    If you want to know the full size of a directory, you can use the du command:



    du -sh directory1 directory2


    will print the size of the directory and all its contents.



    To actually solve your problem, you could use user (or group) quotas. This would allow you to get a detailled report of how much space each user/group is taking and set hard limits about how much space they may use.






    share|improve this answer










    New contributor




    Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.




















    • I can't actually solve the problem since I am not the admin. What usually happens is: I realise that the storage is full again and have to ask around who could free up some space. The response I usually get is: "I barely use any space on the server, so I can't". The directory tree is not branched by users, but by projects since more than one person is working on the same project.

      – MechEng
      yesterday












    • The problem with the non-admin approach is that if the permissions on a directory are set that you cannot read it/list its contents, you cannot know what is in there and cannot find the space it uses. If it is such a problem, I think the server admin should do something (like group quotas and set one group per project or set up directory quotas).

      – Simon Doppler
      yesterday











    • The solution only working for dirs that I have permission to read would be fine. I agree that it should be the responsibility of the admin... but can we for now just pretend that this is not an option and I would like an answer to the initial question.

      – MechEng
      yesterday











    • @MechEng I updated my answer with a script that does what you want

      – Simon Doppler
      yesterday















    0














    To find the disk usage by all users on the disk, you can use the following script:



    #! /bin/bash

    DIRECTORY_TO_SCAN=/home

    readarray -t user_list<<<"$(cat /etc/passwd | cut -d ':' -f 1)"

    for u in "$user_list[@]" ; do
    printf "Scanning for user: %30s" "$u"
    du -ch $(find "$DIRECTORY_TO_SCAN" -user "$u" 2>/dev/null) 2>/dev/null | sed -e '/total/!d;s/^/ /'
    done


    This script will scan the list of all users, find the files you can read and they own and compute the total space those files use.




    (The part below is kept for the sake of completeness)



    If you want to know the full size of a directory, you can use the du command:



    du -sh directory1 directory2


    will print the size of the directory and all its contents.



    To actually solve your problem, you could use user (or group) quotas. This would allow you to get a detailled report of how much space each user/group is taking and set hard limits about how much space they may use.






    share|improve this answer










    New contributor




    Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.




















    • I can't actually solve the problem since I am not the admin. What usually happens is: I realise that the storage is full again and have to ask around who could free up some space. The response I usually get is: "I barely use any space on the server, so I can't". The directory tree is not branched by users, but by projects since more than one person is working on the same project.

      – MechEng
      yesterday












    • The problem with the non-admin approach is that if the permissions on a directory are set that you cannot read it/list its contents, you cannot know what is in there and cannot find the space it uses. If it is such a problem, I think the server admin should do something (like group quotas and set one group per project or set up directory quotas).

      – Simon Doppler
      yesterday











    • The solution only working for dirs that I have permission to read would be fine. I agree that it should be the responsibility of the admin... but can we for now just pretend that this is not an option and I would like an answer to the initial question.

      – MechEng
      yesterday











    • @MechEng I updated my answer with a script that does what you want

      – Simon Doppler
      yesterday













    0












    0








    0







    To find the disk usage by all users on the disk, you can use the following script:



    #! /bin/bash

    DIRECTORY_TO_SCAN=/home

    readarray -t user_list<<<"$(cat /etc/passwd | cut -d ':' -f 1)"

    for u in "$user_list[@]" ; do
    printf "Scanning for user: %30s" "$u"
    du -ch $(find "$DIRECTORY_TO_SCAN" -user "$u" 2>/dev/null) 2>/dev/null | sed -e '/total/!d;s/^/ /'
    done


    This script will scan the list of all users, find the files you can read and they own and compute the total space those files use.




    (The part below is kept for the sake of completeness)



    If you want to know the full size of a directory, you can use the du command:



    du -sh directory1 directory2


    will print the size of the directory and all its contents.



    To actually solve your problem, you could use user (or group) quotas. This would allow you to get a detailled report of how much space each user/group is taking and set hard limits about how much space they may use.






    share|improve this answer










    New contributor




    Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.










    To find the disk usage by all users on the disk, you can use the following script:



    #! /bin/bash

    DIRECTORY_TO_SCAN=/home

    readarray -t user_list<<<"$(cat /etc/passwd | cut -d ':' -f 1)"

    for u in "$user_list[@]" ; do
    printf "Scanning for user: %30s" "$u"
    du -ch $(find "$DIRECTORY_TO_SCAN" -user "$u" 2>/dev/null) 2>/dev/null | sed -e '/total/!d;s/^/ /'
    done


    This script will scan the list of all users, find the files you can read and they own and compute the total space those files use.




    (The part below is kept for the sake of completeness)



    If you want to know the full size of a directory, you can use the du command:



    du -sh directory1 directory2


    will print the size of the directory and all its contents.



    To actually solve your problem, you could use user (or group) quotas. This would allow you to get a detailled report of how much space each user/group is taking and set hard limits about how much space they may use.







    share|improve this answer










    New contributor




    Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.









    share|improve this answer



    share|improve this answer








    edited yesterday





















    New contributor




    Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.









    answered yesterday









    Simon DopplerSimon Doppler

    1063




    1063




    New contributor




    Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.





    New contributor





    Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.






    Simon Doppler is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.












    • I can't actually solve the problem since I am not the admin. What usually happens is: I realise that the storage is full again and have to ask around who could free up some space. The response I usually get is: "I barely use any space on the server, so I can't". The directory tree is not branched by users, but by projects since more than one person is working on the same project.

      – MechEng
      yesterday












    • The problem with the non-admin approach is that if the permissions on a directory are set that you cannot read it/list its contents, you cannot know what is in there and cannot find the space it uses. If it is such a problem, I think the server admin should do something (like group quotas and set one group per project or set up directory quotas).

      – Simon Doppler
      yesterday











    • The solution only working for dirs that I have permission to read would be fine. I agree that it should be the responsibility of the admin... but can we for now just pretend that this is not an option and I would like an answer to the initial question.

      – MechEng
      yesterday











    • @MechEng I updated my answer with a script that does what you want

      – Simon Doppler
      yesterday

















    • I can't actually solve the problem since I am not the admin. What usually happens is: I realise that the storage is full again and have to ask around who could free up some space. The response I usually get is: "I barely use any space on the server, so I can't". The directory tree is not branched by users, but by projects since more than one person is working on the same project.

      – MechEng
      yesterday












    • The problem with the non-admin approach is that if the permissions on a directory are set that you cannot read it/list its contents, you cannot know what is in there and cannot find the space it uses. If it is such a problem, I think the server admin should do something (like group quotas and set one group per project or set up directory quotas).

      – Simon Doppler
      yesterday











    • The solution only working for dirs that I have permission to read would be fine. I agree that it should be the responsibility of the admin... but can we for now just pretend that this is not an option and I would like an answer to the initial question.

      – MechEng
      yesterday











    • @MechEng I updated my answer with a script that does what you want

      – Simon Doppler
      yesterday
















    I can't actually solve the problem since I am not the admin. What usually happens is: I realise that the storage is full again and have to ask around who could free up some space. The response I usually get is: "I barely use any space on the server, so I can't". The directory tree is not branched by users, but by projects since more than one person is working on the same project.

    – MechEng
    yesterday






    I can't actually solve the problem since I am not the admin. What usually happens is: I realise that the storage is full again and have to ask around who could free up some space. The response I usually get is: "I barely use any space on the server, so I can't". The directory tree is not branched by users, but by projects since more than one person is working on the same project.

    – MechEng
    yesterday














    The problem with the non-admin approach is that if the permissions on a directory are set that you cannot read it/list its contents, you cannot know what is in there and cannot find the space it uses. If it is such a problem, I think the server admin should do something (like group quotas and set one group per project or set up directory quotas).

    – Simon Doppler
    yesterday





    The problem with the non-admin approach is that if the permissions on a directory are set that you cannot read it/list its contents, you cannot know what is in there and cannot find the space it uses. If it is such a problem, I think the server admin should do something (like group quotas and set one group per project or set up directory quotas).

    – Simon Doppler
    yesterday













    The solution only working for dirs that I have permission to read would be fine. I agree that it should be the responsibility of the admin... but can we for now just pretend that this is not an option and I would like an answer to the initial question.

    – MechEng
    yesterday





    The solution only working for dirs that I have permission to read would be fine. I agree that it should be the responsibility of the admin... but can we for now just pretend that this is not an option and I would like an answer to the initial question.

    – MechEng
    yesterday













    @MechEng I updated my answer with a script that does what you want

    – Simon Doppler
    yesterday





    @MechEng I updated my answer with a script that does what you want

    – Simon Doppler
    yesterday













    0














    In situations like this, I usually first use du -kx | sort -rn | less to list the directories in a largest-first order. That tells me where the biggest individual disk hogs are, so I'll know where to look. But as @SimonDoppler said, if you don't have at least r-x access to all the sub-directories, your listing will be incomplete: you'll only be able to get the sizes of directories you'll be able to access.



    Remember: normally you only need to have write access to a directory to delete any files in it. Only if the directory has the sticky bit set (i.e. the last letter in the permission letter string is a t instead of x), you need be the owner of the file in order to delete it.



    If there is no quota available, you may need to do something like this:



    #!/bin/sh
    if [ "$1" = "" ] || [ "$1" = "-h" ]
    then
    echo "Usage: $0##*/ <directory> <username(s)...>" >&2
    exit 64 # EX_USAGE
    fi
    if ! [ -d "$1" ]
    then
    echo "ERROR: directory $1 does not exist" >&2
    exit 66 # EX_NOINPUT
    fi

    REPORTROOT="$1"
    shift
    for U in "$@"
    do
    # Find all files under $REPORTROOT owned by a particular user,
    # get their sizes and sum them together.
    DISKUSE=$(find "$REPORTROOT" -type f -user "$U"
    -exec stat -c %s + 2>/dev/null
    | awk 's+=$1 END printf("%ldn", s)')
    # Display the result for this user.
    printf "%16s: %dn" "$U" "$DISKUSE"
    done


    Note that running this may take a while.



    The "calculate a sum of a list of numbers" awk one-liner is from this Stack Overflow post. Note the comments of the answer.






    share|improve this answer



























      0














      In situations like this, I usually first use du -kx | sort -rn | less to list the directories in a largest-first order. That tells me where the biggest individual disk hogs are, so I'll know where to look. But as @SimonDoppler said, if you don't have at least r-x access to all the sub-directories, your listing will be incomplete: you'll only be able to get the sizes of directories you'll be able to access.



      Remember: normally you only need to have write access to a directory to delete any files in it. Only if the directory has the sticky bit set (i.e. the last letter in the permission letter string is a t instead of x), you need be the owner of the file in order to delete it.



      If there is no quota available, you may need to do something like this:



      #!/bin/sh
      if [ "$1" = "" ] || [ "$1" = "-h" ]
      then
      echo "Usage: $0##*/ <directory> <username(s)...>" >&2
      exit 64 # EX_USAGE
      fi
      if ! [ -d "$1" ]
      then
      echo "ERROR: directory $1 does not exist" >&2
      exit 66 # EX_NOINPUT
      fi

      REPORTROOT="$1"
      shift
      for U in "$@"
      do
      # Find all files under $REPORTROOT owned by a particular user,
      # get their sizes and sum them together.
      DISKUSE=$(find "$REPORTROOT" -type f -user "$U"
      -exec stat -c %s + 2>/dev/null
      | awk 's+=$1 END printf("%ldn", s)')
      # Display the result for this user.
      printf "%16s: %dn" "$U" "$DISKUSE"
      done


      Note that running this may take a while.



      The "calculate a sum of a list of numbers" awk one-liner is from this Stack Overflow post. Note the comments of the answer.






      share|improve this answer

























        0












        0








        0







        In situations like this, I usually first use du -kx | sort -rn | less to list the directories in a largest-first order. That tells me where the biggest individual disk hogs are, so I'll know where to look. But as @SimonDoppler said, if you don't have at least r-x access to all the sub-directories, your listing will be incomplete: you'll only be able to get the sizes of directories you'll be able to access.



        Remember: normally you only need to have write access to a directory to delete any files in it. Only if the directory has the sticky bit set (i.e. the last letter in the permission letter string is a t instead of x), you need be the owner of the file in order to delete it.



        If there is no quota available, you may need to do something like this:



        #!/bin/sh
        if [ "$1" = "" ] || [ "$1" = "-h" ]
        then
        echo "Usage: $0##*/ <directory> <username(s)...>" >&2
        exit 64 # EX_USAGE
        fi
        if ! [ -d "$1" ]
        then
        echo "ERROR: directory $1 does not exist" >&2
        exit 66 # EX_NOINPUT
        fi

        REPORTROOT="$1"
        shift
        for U in "$@"
        do
        # Find all files under $REPORTROOT owned by a particular user,
        # get their sizes and sum them together.
        DISKUSE=$(find "$REPORTROOT" -type f -user "$U"
        -exec stat -c %s + 2>/dev/null
        | awk 's+=$1 END printf("%ldn", s)')
        # Display the result for this user.
        printf "%16s: %dn" "$U" "$DISKUSE"
        done


        Note that running this may take a while.



        The "calculate a sum of a list of numbers" awk one-liner is from this Stack Overflow post. Note the comments of the answer.






        share|improve this answer













        In situations like this, I usually first use du -kx | sort -rn | less to list the directories in a largest-first order. That tells me where the biggest individual disk hogs are, so I'll know where to look. But as @SimonDoppler said, if you don't have at least r-x access to all the sub-directories, your listing will be incomplete: you'll only be able to get the sizes of directories you'll be able to access.



        Remember: normally you only need to have write access to a directory to delete any files in it. Only if the directory has the sticky bit set (i.e. the last letter in the permission letter string is a t instead of x), you need be the owner of the file in order to delete it.



        If there is no quota available, you may need to do something like this:



        #!/bin/sh
        if [ "$1" = "" ] || [ "$1" = "-h" ]
        then
        echo "Usage: $0##*/ <directory> <username(s)...>" >&2
        exit 64 # EX_USAGE
        fi
        if ! [ -d "$1" ]
        then
        echo "ERROR: directory $1 does not exist" >&2
        exit 66 # EX_NOINPUT
        fi

        REPORTROOT="$1"
        shift
        for U in "$@"
        do
        # Find all files under $REPORTROOT owned by a particular user,
        # get their sizes and sum them together.
        DISKUSE=$(find "$REPORTROOT" -type f -user "$U"
        -exec stat -c %s + 2>/dev/null
        | awk 's+=$1 END printf("%ldn", s)')
        # Display the result for this user.
        printf "%16s: %dn" "$U" "$DISKUSE"
        done


        Note that running this may take a while.



        The "calculate a sum of a list of numbers" awk one-liner is from this Stack Overflow post. Note the comments of the answer.







        share|improve this answer












        share|improve this answer



        share|improve this answer










        answered yesterday









        telcoMtelcoM

        20.1k12450




        20.1k12450




















            MechEng is a new contributor. Be nice, and check out our Code of Conduct.









            draft saved

            draft discarded


















            MechEng is a new contributor. Be nice, and check out our Code of Conduct.












            MechEng is a new contributor. Be nice, and check out our Code of Conduct.











            MechEng is a new contributor. Be nice, and check out our Code of Conduct.














            Thanks for contributing an answer to Unix & Linux Stack Exchange!


            • Please be sure to answer the question. Provide details and share your research!

            But avoid


            • Asking for help, clarification, or responding to other answers.

            • Making statements based on opinion; back them up with references or personal experience.

            To learn more, see our tips on writing great answers.




            draft saved


            draft discarded














            StackExchange.ready(
            function ()
            StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508673%2ffind-out-which-users-are-hogging-the-most-disk-space-on-our-data-server%23new-answer', 'question_page');

            );

            Post as a guest















            Required, but never shown





















































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown

































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown







            Popular posts from this blog

            Àrd-bhaile Cathair chruinne/Baile mòr cruinne | Artagailean ceangailte | Clàr-taice na seòladaireachd

            대한민국 목차 국명 지리 역사 정치 국방 경제 사회 문화 국제 순위 관련 항목 각주 외부 링크 둘러보기 메뉴북위 37° 34′ 08″ 동경 126° 58′ 36″ / 북위 37.568889° 동경 126.976667°  / 37.568889; 126.976667ehThe Korean Repository문단을 편집문단을 편집추가해Clarkson PLC 사Report for Selected Countries and Subjects-Korea“Human Development Index and its components: P.198”“http://www.law.go.kr/%EB%B2%95%EB%A0%B9/%EB%8C%80%ED%95%9C%EB%AF%BC%EA%B5%AD%EA%B5%AD%EA%B8%B0%EB%B2%95”"한국은 국제법상 한반도 유일 합법정부 아니다" - 오마이뉴스 모바일Report for Selected Countries and Subjects: South Korea격동의 역사와 함께한 조선일보 90년 : 조선일보 인수해 혁신시킨 신석우, 임시정부 때는 '대한민국' 국호(國號) 정해《우리가 몰랐던 우리 역사: 나라 이름의 비밀을 찾아가는 역사 여행》“남북 공식호칭 ‘남한’‘북한’으로 쓴다”“Corea 대 Korea, 누가 이긴 거야?”국내기후자료 - 한국[김대중 前 대통령 서거] 과감한 구조개혁 'DJ노믹스'로 최단기간 환란극복 :: 네이버 뉴스“이라크 "韓-쿠르드 유전개발 MOU 승인 안해"(종합)”“해외 우리국민 추방사례 43%가 일본”차기전차 K2'흑표'의 세계 최고 전력 분석, 쿠키뉴스 엄기영, 2007-03-02두산인프라, 헬기잡는 장갑차 'K21'...내년부터 공급, 고뉴스 이대준, 2008-10-30과거 내용 찾기mk 뉴스 - 구매력 기준으로 보면 한국 1인당 소득 3만弗과거 내용 찾기"The N-11: More Than an Acronym"Archived조선일보 최우석, 2008-11-01Global 500 2008: Countries - South Korea“몇년째 '시한폭탄'... 가계부채, 올해는 터질까”가구당 부채 5000만원 처음 넘어서“‘빚’으로 내몰리는 사회.. 위기의 가계대출”“[경제365] 공공부문 부채 급증…800조 육박”“"소득 양극화 다소 완화...불평등은 여전"”“공정사회·공생발전 한참 멀었네”iSuppli,08年2QのDRAMシェア・ランキングを発表(08/8/11)South Korea dominates shipbuilding industry | Stock Market News & Stocks to Watch from StraightStocks한국 자동차 생산, 3년 연속 세계 5위자동차수출 '현대-삼성 웃고 기아-대우-쌍용은 울고' 과거 내용 찾기동반성장위 창립 1주년 맞아Archived"중기적합 3개업종 합의 무시한 채 선정"李대통령, 사업 무분별 확장 소상공인 생계 위협 질타삼성-LG, 서민업종인 빵·분식사업 잇따라 철수상생은 뒷전…SSM ‘몸집 불리기’ 혈안Archived“경부고속도에 '아시안하이웨이' 표지판”'철의 실크로드' 앞서 '말(言)의 실크로드'부터, 프레시안 정창현, 2008-10-01“'서울 지하철은 안전한가?'”“서울시 “올해 안에 모든 지하철역 스크린도어 설치””“부산지하철 1,2호선 승강장 안전펜스 설치 완료”“전교조, 정부 노조 통계서 처음 빠져”“[Weekly BIZ] 도요타 '제로 이사회'가 리콜 사태 불러들였다”“S Korea slams high tuition costs”““정치가 여론 양극화 부채질… 합리주의 절실””“〈"`촛불집회'는 민주주의의 질적 변화 상징"〉”““촛불집회가 민주주의 왜곡 초래””“국민 65%, "한국 노사관계 대립적"”“한국 국가경쟁력 27위‥노사관계 '꼴찌'”“제대로 형성되지 않은 대한민국 이념지형”“[신년기획-갈등의 시대] 갈등지수 OECD 4위…사회적 손실 GDP 27% 무려 300조”“2012 총선-대선의 키워드는 '국민과 소통'”“한국 삶의 질 27위, 2000년과 2008년 연속 하위권 머물러”“[해피 코리아] 행복점수 68점…해외 평가선 '낙제점'”“한국 어린이·청소년 행복지수 3년 연속 OECD ‘꼴찌’”“한국 이혼율 OECD중 8위”“[통계청] 한국 이혼율 OECD 4위”“오피니언 [이렇게 생각한다] `부부의 날` 에 돌아본 이혼율 1위 한국”“Suicide Rates by Country, Global Health Observatory Data Repository.”“1. 또 다른 차별”“오피니언 [편집자에게] '왕따'와 '패거리 정치' 심리는 닮은꼴”“[미래한국리포트] 무한경쟁에 빠진 대한민국”“대학생 98% "외모가 경쟁력이라는 말 동의"”“특급호텔 웨딩·200만원대 유모차… "남보다 더…" 호화病, 고질병 됐다”“[스트레스 공화국] ① 경쟁사회, 스트레스 쌓인다”““매일 30여명 자살 한국, 의사보다 무속인에…””“"자살 부르는 '우울증', 환자 중 85% 치료 안 받아"”“정신병원을 가다”“대한민국도 ‘묻지마 범죄’,안전지대 아니다”“유엔 "학생 '성적 지향'에 따른 차별 금지하라"”“유엔아동권리위원회 보고서 및 번역본 원문”“고졸 성공스토리 담은 '제빵왕 김탁구' 드라마 나온다”“‘빛 좋은 개살구’ 고졸 취업…실습 대신 착취”원본 문서“정신건강, 사회적 편견부터 고쳐드립니다”‘소통’과 ‘행복’에 목 마른 사회가 잠들어 있던 ‘심리학’ 깨웠다“[포토] 사유리-곽금주 교수의 유쾌한 심리상담”“"올해 한국인 평균 영화관람횟수 세계 1위"(종합)”“[게임연중기획] 게임은 문화다-여가활동 1순위 게임”“영화속 ‘영어 지상주의’ …“왠지 씁쓸한데””“2월 `신문 부수 인증기관` 지정..방송법 후속작업”“무료신문 성장동력 ‘차별성’과 ‘갈등해소’”대한민국 국회 법률지식정보시스템"Pew Research Center's Religion & Public Life Project: South Korea"“amp;vwcd=MT_ZTITLE&path=인구·가구%20>%20인구총조사%20>%20인구부문%20>%20 총조사인구(2005)%20>%20전수부문&oper_YN=Y&item=&keyword=종교별%20인구& amp;lang_mode=kor&list_id= 2005년 통계청 인구 총조사”원본 문서“한국인이 좋아하는 취미와 운동 (2004-2009)”“한국인이 좋아하는 취미와 운동 (2004-2014)”Archived“한국, `부분적 언론자유국' 강등〈프리덤하우스〉”“국경없는기자회 "한국, 인터넷감시 대상국"”“한국, 조선산업 1위 유지(S. Korea Stays Top Shipbuilding Nation) RZD-Partner Portal”원본 문서“한국, 4년 만에 ‘선박건조 1위’”“옛 마산시,인터넷속도 세계 1위”“"한국 초고속 인터넷망 세계1위"”“인터넷·휴대폰 요금, 외국보다 훨씬 비싸”“한국 관세행정 6년 연속 세계 '1위'”“한국 교통사고 사망자 수 OECD 회원국 중 2위”“결핵 후진국' 한국, 환자가 급증한 이유는”“수술은 신중해야… 자칫하면 생명 위협”대한민국분류대한민국의 지도대한민국 정부대표 다국어포털대한민국 전자정부대한민국 국회한국방송공사about korea and information korea브리태니커 백과사전(한국편)론리플래닛의 정보(한국편)CIA의 세계 정보(한국편)마리암 부디아 (Mariam Budia),『한국: 하늘이 내린 한 폭의 그림』, 서울: 트랜스라틴 19호 (2012년 3월)대한민국ehehehehehehehehehehehehehehWorldCat132441370n791268020000 0001 2308 81034078029-6026373548cb11863345f(데이터)00573706ge128495

            Cannot Extend partition with GParted The 2019 Stack Overflow Developer Survey Results Are In Announcing the arrival of Valued Associate #679: Cesar Manara Planned maintenance scheduled April 17/18, 2019 at 00:00UTC (8:00pm US/Eastern) 2019 Community Moderator Election ResultsCan't increase partition size with GParted?GParted doesn't recognize the unallocated space after my current partitionWhat is the best way to add unallocated space located before to Ubuntu 12.04 partition with GParted live?I can't figure out how to extend my Arch home partition into free spaceGparted Linux Mint 18.1 issueTrying to extend but swap partition is showing as Unknown in Gparted, shows proper from fdiskRearrange partitions in gparted to extend a partitionUnable to extend partition even though unallocated space is next to it using GPartedAllocate free space to root partitiongparted: how to merge unallocated space with a partition